<?php
// $Id: apachesolr_ajax.admin.inc,v 1.1 2009/10/07 22:23:31 jpmckinney Exp $

/**
 * @file
 * Provides the administration settings for this module.
 */

/**
 * Menu callback; Settings administration.
 */
function apachesolr_ajax_admin_settings() {
  $form['proxy'] = array(
    '#type' => 'fieldset',
    '#title' => t('Proxy settings'),
  );
  $form['proxy']['apachesolr_ajax_proxy_queries'] = array(
    '#type' => 'checkbox',
    '#title' => t('Proxy queries thru Drupal'),
    '#description' => t('For added security, you can pass queries through Drupal, if you do not with to expose your Solr server to the Internet.'),
    '#default_value' => variable_get('apachesolr_ajax_proxy_queries', TRUE),
  );
  $form['proxy']['apachesolr_ajax_proxy_fields'] = array(
    '#type' => 'textfield',
    '#title' => t('Allowed fields'),
    '#description' => t('A comma-separated list of fields that can be fetched for display through the proxy. Leave blank for all.'),
    '#default_value' => variable_get('apachesolr_ajax_proxy_fields', ''),
  );
  $form['proxy']['apachesolr_ajax_proxy_max_rows'] = array(
    '#type' => 'textfield',
    '#title' => t('Max rows'),
    '#description' => t('The maximum number of rows that can be fetched through the proxy. Leave blank for unlimited.'),
    '#default_value' => variable_get('apachesolr_ajax_proxy_max_rows', NULL),
  );

  $form['widget'] = array(
    '#type' => 'fieldset',
    '#title' => t('Widget Settings'),
  );
  $form['widget']['apachesolr_ajax_date_granularity'] = array(
    '#type' => 'select',
    '#title' => t('Date widget granularity'),
    '#description' => t('Users will be able to facet up to this level of granularity.'),
    '#options' => array(
      'YEAR' => 'Year',
      'MONTH' => 'Month',
      'DAY' => 'Day',
      'HOUR' => 'Hour',
      'MINUTE' => 'Minute',
      'SECOND' => 'Second',
    ),
    '#default_value' => variable_get('apachesolr_ajax_date_granularity', 'MINUTE'),
  );

  return system_settings_form($form);
}
