// $Id: ExpandingFacetWidget.js,v 1.1 2009/10/07 22:23:31 jpmckinney Exp $

(function($) {

/**
 * @expects this.target to be a list.
 */
AjaxSolr.ExpandingFacetWidget = AjaxSolr.AbstractFacetWidget.extend({
  abridged: true,

  /**
   * The number of columns used to display the values.
   *
   * @field
   * @private
   */
  columns: 0,

  _handleResult: function() {
    AjaxSolr.theme('list_items', this.target, this.facetColumns());
    this.popIn();
  },

  /**
   * @see facetLinks() in FacetWidget.
   */
  facetLinks: function() {
    var links = [];

    for (var facet in this.facetFields) {
      if (AjaxSolr.contains(this.selectedItems, facet)) {
        links.push(Drupal.theme('apachesolr_unclick_link', this.unclickText(facet), this.unclickHandler(facet)));
      }
      else {
        links.push(Drupal.theme('apachesolr_facet_link', this.clickText(facet), this.clickHandler(facet), {}, this.facetFields[facet]));
      }
    }

    return this.alterFacetLinks(links);
  },

  /**
   * @see alterFacetLinks() in FacetWidget.
   */
  alterFacetLinks: function(links) {
    return links;
  },

  facetColumns: function() {
    var columns = [];

    var links = this.facetLinks();

    this.columns = 0;
    for (start = 0; start < links.length; start += this.limit) {
      var end = Math.min(start + this.limit, links.length);

      var column = $('<ul/>');
      AjaxSolr.theme('list_items', column, links.slice(start, end));
      columns.push(column);

      this.columns++;
    }

    return columns;
  },

  popOut: function() {
    $(this.target + ' > li:gt(0)').show();

    // Make all columns as wide as the widest column.
    var width = 0;
    var columns = $(this.target + ' ul');
    for (var i = 0; i < columns.length; i++) {
      width = Math.max(width, $(columns[i]).width() + 1);
    }
    columns.width(width);

    $(this.container).addClass('expanded-facet-container');
    $(this.target).addClass('expanded-facet-target');
    $(this.container + ' .item-list').width($(this.target + ' ul').outerWidth() * this.columns);
    $(this.container).find('.apachesolr-showhide').text(Drupal.t('Show less'));
    this.abridged = false;
  },

  popIn: function() {
    $(this.target + ' > li:gt(0)').hide();

    $(this.container).removeClass('expanded-facet-container');
    $(this.target).removeClass('expanded-facet-target');
    $(this.container + ' .item-list').css('width', null);
    $(this.container).find('.apachesolr-showhide').text(Drupal.t('Show more'));
    this.abridged = true;
  },

  afterAdditionToManager: function() {
    $(this.container).addClass('expandable-facet-container');
    $(this.target).addClass('expandable-facet-target');

    $(this.target).empty();

    var me = this;
    var link = $('<a href="#" class="apachesolr-showhide"/>').text(Drupal.t('Show more')).click(function() {
      if (me.abridged) {
        me.popOut();
      }
      else {
        me.popIn();
      }
      return false;
    });

    $(this.target).after(link);
  }
});

})(jQuery);
