// $Id: CurrentSearchWidget.js,v 1.1 2009/10/07 22:23:31 jpmckinney Exp $

(function($) {

/**
 * @expects this.target to be a list.
 * @expects this.container to contain an h3.
 */
AjaxSolr.CurrentSearchWidget = AjaxSolr.AbstractWidget.extend({
  displayQuery: function(queryObj) {
    var links = this.unclickLinks(queryObj);
    AjaxSolr.theme('list_items', this.target, links);
    $(this.container).showIf(links.length);
  },

  /**
   * @see case 'currentsearch' in apachesolr_search_block()
   */
  unclickLinks: function(queryObj) {
    var links = [];

    for (var i in queryObj.q) {
      if (queryObj.q[i].value == '') continue;
      var query = queryObj.q[i].value, widget = this.manager.widgets.text;
      links.push([ Drupal.apachesolr_l(query, widget.unclickHandler()) ]);
    }

    for (var i in queryObj.fq) {
      if (queryObj.fq[i].hidden) continue;
      var facet = queryObj.fq[i].value, widget = this.manager.widgets[queryObj.fq[i].widgetId];
      links.push(Drupal.theme('apachesolr_unclick_link', widget.unclickText(facet), widget.unclickHandler(facet)));
    }

    return links;
  },

  /**
   * @see theme_apachesolr_currentsearch()
   */
  handleResult: function(data) {
    $(this.container).find('h3').text(Drupal.formatPlural(parseInt(data.response.numFound), 'Search found 1 item', 'Search found @count items'));
  }
});

})(jQuery);
