// $Id: FacetWidget.js,v 1.1 2009/10/07 22:23:31 jpmckinney Exp $

(function($) {

/**
 * @expects this.target to be a list.
 */
AjaxSolr.FacetWidget = AjaxSolr.AbstractFacetWidget.extend({
  limit: 10,

  /**
   * Whether the list of facet values is currently abridged.
   *
   * @field
   * @private
   */
  abridged: true,

  _handleResult: function() {
    AjaxSolr.theme('list_items', this.target, this.facetLinks());
    this.renderContainer();
  },

  facetLinks: function() {
    var links = [];

    for (var facet in this.facetFields) {
      if (AjaxSolr.contains(this.selectedItems, facet)) {
        links.push(Drupal.theme('apachesolr_unclick_link', this.unclickText(facet), this.unclickHandler(facet)));
      }
      else {
        links.push(Drupal.theme('apachesolr_facet_link', this.clickText(facet), this.clickHandler(facet), {}, this.facetFields[facet]));
      }
    }

    return this.alterFacetLinks(links);
  },

  /**
   * An abstract hook for child implementations.
   * Optionally alters the facet links.
   */
  alterFacetLinks: function(links) {
    return links;
  },

  /**
   * Control abridgment of facet list
   */
  renderContainer: function() {
    var count = $(this.target).find('li').length;

    $(this.container).showIf(count);

    if (this.abridged && count > this.limit) {
      $(this.target).find('li:gt(' + (this.limit - 1) + ')').hide();
    }

    $(this.container).find('.apachesolr-showhide').showIf(count > this.limit);
  },

  /**
   * @see apachesolr.js
   */
  afterAdditionToManager: function() {
    $(this.target).empty();

    var me = this;
    var link = $('<a href="#" class="apachesolr-showhide"/>').text(Drupal.t('Show more')).click(function() {
      if ($(this).prev().find('li:gt(' + (me.limit - 1) + '):visible').length == 0) {
        $(this).prev().find('li:gt(' + (me.limit - 1) + ')').show();
        $(this).text(Drupal.t('Show fewer'));
        me.abridged = false;
      }
      else {
        $(this).prev().find('li:gt(' + (me.limit - 1) + ')').hide();
        $(this).text(Drupal.t('Show more'));
        me.abridged = true;
      }
      return false;
    });

    $(this.target).after(link);
  }
});

})(jQuery);
