// $Id: TextWidget.js,v 1.1 2009/10/07 22:23:31 jpmckinney Exp $

(function($) {

/**
 * @expects this.target to be a form with one text field and one submit button.
 */
AjaxSolr.TextWidget = AjaxSolr.AbstractTextWidget.extend({
  /**
   * Returns a function to deselect all items except those of this widget.
   *
   * @returns {Function}
   */
  unclickHandler: function() {
    var me = this;
    return function() {
      me.manager.selectOnlyWidget(me.id);
      return false;
    };
  },

  afterChangeSelection: function() {
    $(this.target).find('input:text').val(this.selectedItems.join(' '));
  },

  afterAdditionToManager: function() {
    if ($(this.target).find('input:text[value]').val()) {
      this.selectItems([ $(this.target).find('input:text[value]').val() ]);
    }

    var me = this;
    $(this.target).submit(function() {
      var value = [ $(me.target).find('input:text').val() ];
      me.manager.selectItems(me.id, value);
      return false;
    });
  }
});

})(jQuery);
