// $Id: apachesolr.support.js,v 1.1 2009/10/07 22:23:31 jpmckinney Exp $

/**
 * @see http://brandonaaron.net/blog/2007/06/17/jquery-snippets-outerhtml
 */
jQuery.fn.outerHTML = function() {
  return $('<div>').append(this.eq(0).clone()).html();
};

/**
 * @see truncate_utf8()
 */
Drupal.truncateUtf8 = function(string, len, wordsafe, dots) {
  if (string.length <= len) {
    return string;
  }

  if (dots) {
    len -= 4;
  }

  if (wordsafe) {
    string = string.substring(0, len + 1);
    if (last_space = string.lastIndexOf(' ')) {
      string = string.substring(0, last_space);
    }
    else {
      string = string.substring(0, len);
    }
  }
  else {
    string = string.substring(0, len);
  }

  if (dots) {
    string += ' ...';
  }

  return string;
}

/**
 * @see format_date()
 */
Drupal.formatDate = function(timestamp, type, format, timezone, langcode) {
  // skip timezone, assume user's browser has the desired timezone

  switch (type) {
    case 'small':
      format = '%m/%d/%Y - %H:%M'; // m/d/Y - H:i
      break;
    case 'large':
      format = '%A, %B %e, %Y - %H:%M'; // l, F j, Y - H:i
      break;
    case 'custom':
      // No change to format.
      break;
    case 'medium':
    default:
      format = '%a, %m/%d/%Y - %H:%M'; // D, m/d/Y - H:i
  }

  // skip i18n
  date = jQuery.strftime(format, timestamp.toDate(), true);

  return date;
}

/**
 * @see search_help()
 */
Drupal.searchHelp = function(path, arg) {
  switch (path) {
    case 'admin/help#search':
      var output = '<p>' + Drupal.t('The search module adds the ability to search for content by keywords. Search is often the only practical way to find content on a large site, and is useful for finding both users and posts.') + '</p>';
      output += '<p>' + Drupal.t('To provide keyword searching, the search engine maintains an index of words found in your site\'s content. To build and maintain this index, a correctly configured <a href="@cron">cron maintenance task</a> is required. Indexing behavior can be adjusted using the <a href="@searchsettings">search settings page</a>; for example, the <em>Number of items to index per cron run</em> sets the maximum number of items indexed in each pass of a <a href="@cron">cron maintenance task</a>. If necessary, reduce this number to prevent timeouts and memory errors when indexing.', { '@cron': Drupal.url('admin/reports/status'), '@searchsettings': Drupal.url('admin/settings/search') }) + '</p>';
      output += '<p>' + Drupal.t('For more information, see the online handbook entry for <a href="@search">Search module</a>.', { '@search': 'http://drupal.org/handbook/modules/search/' }) + '</p>';
      return output;
    case 'admin/settings/search':
      return '<p>' + Drupal.t('The search engine maintains an index of words found in your site\'s content. To build and maintain this index, a correctly configured <a href="@cron">cron maintenance task</a> is required. Indexing behavior can be adjusted using the settings below.', { '@cron': Drupal.url('admin/reports/status') }) + '</p>';
    case 'search#noresults':
      return Drupal.t('<ul>\
<li>Check if your spelling is correct.</li>\
<li>Remove quotes around phrases to match each word individually: <em>"blue smurf"</em> will match less than <em>blue smurf</em>.</li>\
<li>Consider loosening your query with <em>OR</em>: <em>blue smurf</em> will match less than <em>blue OR smurf</em>.</li>\
</ul>');
  }
}

/**
 * @see drupal_help_arg()
 */
Drupal.drupalHelpArg = function(arg) {
  arg = arg || [];
  return arg.concat([ '', '', '', '', '', '', '', '', '', '', '', '' ]);
}

/**
 * @see apachesolr_l()
 */
Drupal.apachesolr_l = function(text, handler, options) {
  options = options || {};
  return jQuery(Drupal.l(text, '#', options)).click(handler);
}
